package pack

import (
	"github.com/caixw/lib.go/conv"
	"youngee_m_api/model/http_model"
)

func MGormProjectTaskToHttpProjectTaskPreview(gormProjectTaskInfos []*http_model.ProjectTaskInfo) []*http_model.ProjectTaskPreview {
	var httpProjectPreviews []*http_model.ProjectTaskPreview
	for _, gormProjectTaskInfo := range gormProjectTaskInfos {
		httpProjectTaskPreview := GormFullProjectToHttpProjectTaskPreview(gormProjectTaskInfo)
		httpProjectPreviews = append(httpProjectPreviews, httpProjectTaskPreview)
	}
	return httpProjectPreviews
}

func GormFullProjectToHttpProjectTaskPreview(projectTaskInfo *http_model.ProjectTaskInfo) *http_model.ProjectTaskPreview {
	createDate := conv.MustString(projectTaskInfo.CreateDate, "")
	createDate = createDate[0:19]
	return &http_model.ProjectTaskPreview{
		TaskId:             conv.MustString(projectTaskInfo.TaskID, ""),
		PlatformNickname:   conv.MustString(projectTaskInfo.PlatformNickname, ""),
		FansCount:          conv.MustString(projectTaskInfo.FansCount, ""),
		HomePageCaptureUrl: conv.MustString(projectTaskInfo.HomePageCaptureUrl, ""),
		StrategyId:         conv.MustString(projectTaskInfo.StrategyID, ""),
		TaskReward:         conv.MustString(projectTaskInfo.TaskReward, ""),
		HomePageUrl:        conv.MustString(projectTaskInfo.HomePageUrl, ""),
		TaskStatus:         conv.MustString(projectTaskInfo.TaskStatus, ""),
		CreateDate:         createDate,
	}
}

func TaskAccountToTaskInfo(taskAccounts []*http_model.TaskAccount) []*http_model.ProjectTaskInfo {
	var projectTasks []*http_model.ProjectTaskInfo
	for _, taskAccount := range taskAccounts {
		projectTask := GetTaskInfoStruct(taskAccount)
		projectTasks = append(projectTasks, projectTask)
	}
	return projectTasks
}

func GetTaskInfoStruct(taskAccount *http_model.TaskAccount) *http_model.ProjectTaskInfo {
	return &http_model.ProjectTaskInfo{
		TaskID:             taskAccount.Task.TaskId,
		TaskReward:         taskAccount.Task.TaskReward,
		PlatformNickname:   taskAccount.Account.PlatformNickname,
		CreateDate:         taskAccount.Task.CreateDate,
		HomePageUrl:        taskAccount.Account.HomePageUrl,
		HomePageCaptureUrl: taskAccount.Account.HomePageCaptureUrl,
		FansCount:          taskAccount.Account.FansCount,
		TaskStatus:         string(rune(taskAccount.Task.TaskStatus)),
		StrategyID:         taskAccount.Task.StrategyId,
	}
}
